The Link-Template HTTP Header Field
Internet-Draft draft-ietf-httpapi-link-template-04
Mark Nottingham
Prahran
Australia
mnot@mnot.net
https://www.mnot.net/
01 April 2024
Applications and Real-Time
Building Blocks for HTTP APIs
link relation
This specification defines the Link-Template HTTP header field, providing a means for describing the structure of a link between two resources, so that new links can be generated.
About This Document
The latest revision of this draft can be found at https://ietf-wg-httpapi.github.io/link-template/draft-ietf-httpapi-link-template.html. Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-httpapi-link-template/.
Discussion of this document takes place on the Building Blocks for HTTP APIs Working Group mailing list (mailto:httpapi@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/httpapi/. Subscribe at https://www.ietf.org/mailman/listinfo/httpapi/.
Source for this draft and an issue tracker can be found at https://github.com/ietf-wg-httpapi/link-template.
Introduction
[URI-TEMPLATE] defines a syntax for templates that, when expanded using a set of variables, results in a URI [URI].
This specification defines a HTTP header field [HTTP] for conveying templates for links in the headers of a HTTP message. It is complimentary to the Link header field defined in Section 3 of [WEB-LINKING], which carries links directly.
Notational Conventions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
This specification uses the following terms from [STRUCTURED-FIELDS]: List, String, Display String, Parameter.
The Link-Template Header Field
The Link-Template header field is a Structured Field [STRUCTURED-FIELDS] that serializes one or more links into HTTP message metadata. It is semantically equivalent to the Link header field defined in Section 3 of [WEB-LINKING], except that the link target and link anchor can contain URI Templates [URI-TEMPLATE].
Its value is a List of Strings. Each String is a URI Template, and Parameters on it carry associated metadata.
For example:

Link-Template: "/{username}"; rel="item"

indicates that a resource with the relation type "item" for a given "username" can be found by expanding the "username" variable into the template given.
The link target (as defined in Section 2 of [WEB-LINKING]) is the result of expanding the URI Template [URI-TEMPLATE] (being converted to an absolute URI after expansion, if necessary).
The link context and link relation type for the link (as defined in Section 2 of [WEB-LINKING]) are conveyed using the "anchor" and "rel" Parameters, as they are for the Link header field in Section 3 of [WEB-LINKING]. Their values MUST be Strings.
However, the "anchor" Parameter MAY contain a URI Template. For example:

Link-Template: "/books/{book_id}/author";
               rel="author"; anchor="#{book_id}"

Here, the link to the author for a particular book in a list of books can be found by following the link template.
This specification defines additional semantics for the "var-base" Parameter on templated links; see below.
The link's target attributes (as defined in Section 2.2 of [WEB-LINKING]) are conveyed using other Parameters, in a manner similar to the Link header field. These Parameter values MUST be Strings, unless they contain non-ASCII characters, in which case they MUST be Display Strings. Note that some target attribute names will not serialise as Structured Field Parameter keys (see Section 3.1.2 of [STRUCTURED-FIELDS]).
For example:

Link-Template: "/author"; rel="author";
               title=%"Bj%c3%b6rn J%c3%a4rnsida"

Implementations MUST support all levels of template defined by [URI-TEMPLATE] in the link String and the anchor Parameter.
The 'var-base' parameter
When a templated link has a 'var-base' parameter, its value conveys a URI-reference that is used as a base URI for the variable names in the URI template. This allows template variables to be globally identified, rather than specific to the context of use.
Dereferencing the URI for a particular variable might lead to more information about the syntax or semantics of that variable; specification of particular formats for this information is out of scope for this document.
To determine the URI for a given variable, the value given is used as a base URI in reference resolution (as specified in [URI]). If the resulting URI is still relative, the context of the link is used as the base URI in a further resolution; see [WEB-LINKING].
For example:

Link-Template: "/widgets/{widget_id}";
               rel="https://example.org/rel/widget";
               var-base="https://example.org/vars/"

indicates that a resource with the relation type "https://example.org/rel/widget" can be found by expanding the "https://example.org/vars/widget_id" variable into the template given.
If the current context of the message that the header appears within is "https://example.org/", the same information could be conveyed by this header field:

Link-Template: "/widgets/{widget_id}";
               rel="https://example.org/rel/widget";
               var-base="/vars/"

Security Considerations
The security consideration for the Link header field in [WEB-LINKING] and those for URI Templates [URI-TEMPLATE] both apply.
Target attributes that are conveyed via Display Strings can be vulnerable to a wide variety of attacks. See [UNICODE-SECURITY] for advice regarding their handling. Specific advice is not given by this specification, since there are a variety of potential use cases for such attributes.
IANA Considerations
This specification enters the "Link-Template" into the Hypertext Transfer Protocol (HTTP) Field Name Registry.
- Field Name: Link-Template
- Status: permanent
- Specification document: [this document]
Normative References
[HTTP]

HTTP Semantics
R. Fielding, Ed.
M. Nottingham, Ed.
J. Reschke, Ed.
June 2022
STD 97
RFC 9110
DOI 10.17487/RFC9110
[URI-TEMPLATE]

URI Template
J. Gregorio
R. Fielding
M. Hadley
M. Nottingham
D. Orchard
March 2012
RFC 6570
DOI 10.17487/RFC6570
[URI]

Uniform Resource Identifier (URI): Generic Syntax
T. Berners-Lee
R. Fielding
L. Masinter
January 2005
STD 66
RFC 3986
DOI 10.17487/RFC3986
[WEB-LINKING]

Web Linking
M. Nottingham
October 2017
RFC 8288
DOI 10.17487/RFC8288
[STRUCTURED-FIELDS]

Structured Field Values for HTTP
Mark Nottingham
Cloudflare
Poul-Henning Kamp
The Varnish Cache Project
23 January 2024
Internet-Draft draft-ietf-httpbis-sfbis-05
[UNICODE-SECURITY]

Unicode Security Considerations
Mark Davis
Michel Suignard
19 September 2014
Unicode Technical Report #16
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174